[BACK]Return to fw_install.sh CVS log [TXT][DIR] Up to [local] / openbsd / fw_update

Diff for /openbsd/fw_update/fw_install.sh between version 1.51 and 1.67

version 1.51, 2021/12/07 02:42:01 version 1.67, 2021/12/11 03:25:09
Line 25 
Line 25 
 VERSION=${VERSION:-"${VNAME%.*}${VNAME#*.}"}  VERSION=${VERSION:-"${VNAME%.*}${VNAME#*.}"}
   
 HTTP_FWDIR="$VNAME"  HTTP_FWDIR="$VNAME"
 VTYPE=$( sed -n "/^OpenBSD $VNAME\([^ ]*\).*$/s//\1/p" /var/run/dmesg.boot | sed '$!d' )  VTYPE=$( sed -n "/^OpenBSD $VNAME\([^ ]*\).*$/s//\1/p" \
       /var/run/dmesg.boot | sed '$!d' )
 [[ $VTYPE == -!(stable) ]] && HTTP_FWDIR=snapshots  [[ $VTYPE == -!(stable) ]] && HTTP_FWDIR=snapshots
   
 FWURL=http://firmware.openbsd.org/firmware/${HTTP_FWDIR}  FWURL=http://firmware.openbsd.org/firmware/${HTTP_FWDIR}
Line 47 
Line 48 
         echo "$_dir"          echo "$_dir"
 }  }
   
   realpath () {
           if [ -x /usr/bin/realpath ]; then
                   /usr/bin/realpath "$1"
           elif [ "$1" = "${1%/*}" ]; then
                   echo "${PWD}/$1"
           else
                   echo "$( cd "${1%/*}" && pwd )/${1##*/}"
           fi
   }
   
 fetch() {  fetch() {
         local _file=$1 _user=_file _exit          local _file=$1 _user=_file _exit
   
         >"$_file"  
         chown "$_user" "$_file"  
   
         # If we're not in the installer, we have su(1)          # If we're not in the installer, we have su(1)
         # and doas(1) is unlikely to be configured.          # and doas(1) is unlikely to be configured.
         if [ -x /usr/bin/sh ]; then          if [ -x /usr/bin/su ]; then
                 /usr/bin/su -s /bin/ksh "$_user" -c \                  /usr/bin/su -s /bin/ksh "$_user" -c \
                     "/usr/bin/ftp -D 'Get/Verify' -Vm \                      "/usr/bin/ftp -D 'Get/Verify' -Vm \
                         -o '$_file' '${FWURL}/${_file}'"                          -o- '${FWURL}/${_file}'" > "$_file"
                 _exit="$?"                  _exit="$?"
         else          else
                 /usr/bin/doas -u "$_user" \                  /usr/bin/doas -u "$_user" \
                     ftp -D 'Get/Verify' -Vm \                      ftp -D 'Get/Verify' -Vm \
                         -o "$_file" "${FWURL}/${_file}"                          -o- "${FWURL}/${_file}" > "$_file"
                 _exit="$?"                  _exit="$?"
         fi          fi
   
Line 72 
Line 80 
                 echo "Cannot fetch $_file" >&2                  echo "Cannot fetch $_file" >&2
                 return 1                  return 1
         fi          fi
   
         chown root "$_file"  
 }  }
   
 verify() {  verify() {
Line 105 
Line 111 
 }  }
   
 firmware_filename() {  firmware_filename() {
         sed -n "s/.*(\($1-firmware-.*\.tgz\)).*/\1/p" "$CFILE" | sed '$!d'          local _f
           _f="$( sed -n "s/.*(\($1-firmware-.*\.tgz\)).*/\1/p" "$CFILE" | sed '$!d' )"
           ! [ "$_f" ] && echo "Unable to find firmware for $1" >&2 && return 1
           echo "$_f"
 }  }
   
   firmware_devicename() {
           local _d="${1##*/}"
           _d="${_d%-firmware-*}"
           echo "$_d"
   }
   
 installed_firmware() {  installed_firmware() {
         for fw in "${DESTDIR}/var/db/pkg/$1-firmware"*; do          for fw in "${DESTDIR}/var/db/pkg/$1-firmware"*; do
                 [ -e "$fw" ] || continue                  [ -e "$fw" ] || continue
Line 116 
Line 131 
 }  }
   
 add_firmware () {  add_firmware () {
         local _f="$1" _pkgdir="${DESTDIR}/var/db/pkg"          local _f="${1##*/}" _pkgdir="${DESTDIR}/var/db/pkg"
         ftp -D "Install" -Vmo- "file:${1}" |          ftp -D "Install" -Vmo- "file:${1}" |
                 tar -s ",^\+,${_pkgdir}/${_f%.tgz}/+," \                  tar -s ",^\+,${_pkgdir}/${_f%.tgz}/+," \
                 -s ",^firmware,${DESTDIR}/etc/firmware," \                  -s ",^firmware,${DESTDIR}/etc/firmware," \
Line 148 
Line 163 
                   ;;                    ;;
                 @*) continue                  @*) continue
                   ;;                    ;;
                 *)  set -A _remove -- "$_cwd/$c" "${_remove[@]}"                  *) set -A _remove -- "$_cwd/$c" "${_remove[@]}"
                   ;;                    ;;
                 esac                  esac
         done < "${_pkgdir}/${_pkg}/+CONTENTS"          done < "${_pkgdir}/${_pkg}/+CONTENTS"
Line 166 
Line 181 
         done          done
 }  }
   
 set -A devices -- $( devices_needing_firmware )  usage() {
           echo "usage: fw_install [-d dir | -L dir] [driver | file [...]]"
           exit 2
   }
   
 if [ ! "${devices:-}" ]; then  DOWNLOADDIR=
   LOCALDIR=
   while getopts d:L: name
   do
          case "$name" in
          d) DOWNLOADDIR=$OPTARG ;;
          L) LOCALDIR=$OPTARG    ;;
          ?) usage 2 ;;
          esac
   done
   shift $((OPTIND - 1))
   
   if [[ -n "$DOWNLOADDIR" && -n "$LOCALDIR" ]]; then
           echo "Cannot use -d and -L" >&2
           usage 2
   fi
   
   set -A devices -- "$@"
   
   [ "${devices[*]:-}" ] ||
       set -A devices -- $( devices_needing_firmware )
   
   if [ ! "${devices[*]:-}" ]; then
         echo "No devices found which need firmware files to be downloaded."          echo "No devices found which need firmware files to be downloaded."
         exit          exit
 fi  fi
   
 TMPDIR=$( tmpdir "${DESTDIR}/tmp/fw_install" )  # Have to find the full path to firmware files
 cd "$TMPDIR"  # so we can cd and still find them later.
   i=0
   while (( i < "${#devices[@]}" )); do
           f="${devices[$i]}"
           d=$( firmware_devicename "$f" )
           if [ -e "$f" ]; then
                   if [ "$DOWNLOADDIR" ]; then
                           echo "Cannot download local file $f" >&2
                           exit 2
                   fi
                   devices[$i]="$d:$( realpath "$f" )"
           fi
           i=$((i + 1))
   done
   
 # To unpriv we need to let the unpriv user into this dir  if [ "$DOWNLOADDIR" ]; then
 chmod go+x .          if ! cd "$DOWNLOADDIR"; then
                   echo "Unable to use $DOWNLOADDIR, make sure it is a directory"
                   exit 2
           fi
   elif [ "$LOCALDIR" ]; then
           if ! cd "$LOCALDIR"; then
                   echo "Unable to use $LOCALDIR, make sure it is a directory"
                   exit 2
           fi
   else
           TMPDIR=$( tmpdir "${DESTDIR}/tmp/fw_install" )
           cd "$TMPDIR"
   fi
   
 fetch "$CFILE"  if ! [[ -n "$LOCALDIR" && -e "$CFILE" ]]; then
 ! signify -Vep "$FWPUB_KEY" -x "$CFILE" -m "$CFILE" &&          fetch "$CFILE"
     echo "Signature check of SHA256.sig failed" >&2 && exit 1          ! signify -qVep "$FWPUB_KEY" -x "$CFILE" -m "$CFILE" &&
               echo "Signature check of SHA256.sig failed" >&2 && exit 1
   fi
   
 for d in "${devices[@]}"; do  for d in "${devices[@]}"; do
         f=$( firmware_filename "$d" )          f="${d##*:}"
         [ "$f" ] || continue          if [ "$f" = "$d" ]; then
                   f=$( firmware_filename "$d" || true )
                   [ "$f" ] || continue
           else
                   d="${d%:*}"
           fi
   
         set -A installed -- $( installed_firmware "$d" )          set -A installed -- $( installed_firmware "$d" )
   
         if [ "${installed:-}" ]; then          if [ ! "$DOWNLOADDIR" ] && [ "${installed[*]:-}" ]; then
                 for i in "${installed[@]:-}"; do                  for i in "${installed[@]}"; do
                         if [ "$f" = "$i.tgz" ]; then                          if [ "${f##*/}" = "$i.tgz" ]; then
                                 echo "$i already installed"                                  echo "$i already installed"
                                 continue 2                                  continue 2
                         fi                          fi
                 done                  done
         fi          fi
   
         fetch  "$f" || continue          if [ ! -e "$f" ]; then
         verify "$f" || continue                  [ "$LOCALDIR" ] && echo "Cannot install $f, not found" >&2 && continue
                   fetch  "$f" || continue
                   verify "$f" || continue
           elif [ "$DOWNLOADDIR" ]; then
                   echo "Already have $f"
                   verify "$f" || continue
           fi
   
         if [ "${installed:-}" ]; then          [ "$DOWNLOADDIR" ] && continue
   
           if [ "${installed[*]:-}" ]; then
                 for i in "${installed[@]}"; do                  for i in "${installed[@]}"; do
                         delete_firmware "$i"                          delete_firmware "$i"
                 done                  done

Legend:
Removed from v.1.51  
changed lines
  Added in v.1.67

FreeBSD-CVSweb <freebsd-cvsweb@FreeBSD.org>